## Plone Web Mail
## Copyright (C) 2004, OPENPROJECTS, http://openprojects.it
## Maintained by Giorgio Pieretti <giorgio.pieretti at openprojects.it>
## Released under GPL version 2
## See LICENSE.txt or http://www.gnu.org/copyleft/gpl.html

from Products.CMFCore.utils import UniqueObject, getToolByName 
from OFS.SimpleItem import SimpleItem 
from Globals import InitializeClass 
from Products.PloneWebMail.config import TOOL_NAME, TOOL_META_TYPE
from email.Message import Message as _Message
from email import Encoders, Header
from email.MIMEBase import MIMEBase
from email.MIMEMultipart import MIMEMultipart
from email.MIMEImage import MIMEImage
from email.MIMEText import MIMEText
from email.Utils import *
from email.Parser import Parser
import imaplib, smtplib, string, re, sys, email, urllib

from AccessControl import ClassSecurityInfo
from OFS.PropertyManager import PropertyManager
from DateTime import DateTime

#from Products.PythonScripts.standard import url_quote

class portal_webmail (SimpleItem, PropertyManager): 
    """ MyTool  .... """ 
    id = TOOL_NAME
    meta_type = TOOL_META_TYPE
    plone_tool = 1 
    security = ClassSecurityInfo()
    _properties=(
        {'id':'UsePortalData','type':'boolean'},
        {'id':'IMAPServer','type':'string'},
	{'id':'SMTPServer','type':'string'},
        {'id':'IncomingFolder','type':'string'},
        {'id':'SentFolder','type':'string'},
        {'id':'TrashFolder','type':'string'},
        {'id':'CharsetCoding','type':'string'},
    )
    manage_options = (PropertyManager.manage_options + SimpleItem.manage_options)

    UsePortalData = 0
    IMAPServer = ''
    SMTPServer = ''
    IncomingFolder = 'INBOX'
    SentFolder = 'INBOX.Sent Items'
    TrashFolder = 'INBOX.Trash'
    CharsetCoding = 'iso-8859-1'
    
    def __init__(self, **kw):
        if kw:
            self.__dict__.update(**kw)
        if not self.__dict__.has_key('UsePortalData'):
            self.__dict__['UsePortalData'] = self.UsePortalData
        if not self.__dict__.has_key('IMAPServer'):
            self.__dict__['IMAPServer'] = self.IMAPServer
        if not self.__dict__.has_key('SMTPServer'):
            self.__dict__['SMTPServer'] = self.SMTPServer
        if not self.__dict__.has_key('IncomingFolder'):
            self.__dict__['IncomingFolder'] = self.IncomingFolder
        if not self.__dict__.has_key('SentFolder'):
            self.__dict__['SentFolder'] = self.SentFolder
        if not self.__dict__.has_key('TrashFolder'):
            self.__dict__['TrashFolder'] = self.TrashFolder
        if not self.__dict__.has_key('CharsetCoding'):
            self.__dict__['CharsetCoding'] = self.CharsetCoding
    

	    
	        

    def emailsInFolder(self, folder):
        """ Enter a specifyed folder and return nemails """
        typ, mailconn = self._log_into_server()
	if typ == 'NO':
	    return typ, mailconn
        else:
            try:
	        typ, [totemails] = mailconn.select(folder)
	        mailconn.logout()
                if typ == 'NO':
                    return typ, 'Folder not found'
	        else:
                    return typ, totemails
            except:
	        return 'NO','Folder not found'
			    
	    



		
			    
    def getHeaders(self, folder=None, start=0, end=10):
        """list mail messages"""
	if folder == None: 
	    if self.UsePortalData: folder=self.IncomingFolder
	    else: folder=self.mailbox_inbox
        typ, mailconn = self._log_into_server()
	if typ == 'NO':
	    return typ, mailconn
        else:
            typ, mailconn, nemails = self._selectFolder(mailconn, folder)
            if typ == 'NO':
	        return typ, mailconn
	    else:
	        start=int(start)
		end=int(end)
		nemails=int(nemails)
                if start>nemails or start<0: start=0
		if end==None or end<0 or end<start or end>nemails: end=nemails
		try: typ, data = mailconn.sort('DATE',self.CharsetCoding,'0:'+str(nemails))
	        except: typ = 'NO'
		if typ == 'NO':
	            # This is 4 IMAP server that cannot accept SORT command .... really bad! :(
		    try: typ, data = mailconn.search(None, 'ALL')
		    except: pass
	        if typ == 'NO':
		    return 'NO', 'Error getting Emails from server'
        	lst = []
		data_lst = str(data[0]).split(" ")
		data_lst.reverse()
		b_data = {}
		b_data = data_lst[start:end]
                for num in b_data:
                    typ, dat = self._fetch_header(mailconn, num)
	            if typ == 'NO':
                        return typ, dat
	            if dat.has_key('From'):
			st_from = dat['From']
                        realname, address  = parseaddr(st_from)
			realname = self.decodeIsoStr(st=realname)
	                dat['From'] = self._format_address(realname,address,1)
		    if dat.has_key('Subject'):
		        dat['Subject'] = self.decodeIsoStr(st=dat['Subject'])
	            lst.append(dat)
	    try: mailconn.logout()
	    except: pass
	    return 'OK', lst
	    
	    	    
	    

	    
	    	    
    def getMailboxes(self, folder=None):
        """
	get Mailboxes List from start.
        returns a tuple with:
	1 or 0 for HAS CHILDREN,
	complete folder name,
	n of emails in the folder
	"""
	typ, mailconn = self._log_into_server()
	if typ == 'NO':
	    return typ, mailconn
	else:
            try:
	        #typ, data = mailconn.list(directory=folder)
		if folder == None: 
		    typ, data = mailconn.list()
		else:
		    typ, data = mailconn.list(directory=folder)
		if typ <> 'OK': 
		    try: mailconn.logout()
	            except: pass
		    return 'NO', 'Cannot retrieve folders list.'
                else:
    	            ris = []
	            for x in range(len(data)):
	                if data[x][-1] == '"':
                            lst_splitted = string.split(data[x],'"')
		            m_name=lst_splitted[3]
	                else:
		            lst_splitted = string.split(data[x],' ')
	                    m_name=lst_splitted[2]
			try:
		            typ, nm = mailconn.select(m_name)
			except:
			    mailconn.logout()
			    return 'NO', 'Cannot retrieve folder list.'
			if typ == 'NO': nm = 'Cannot select IMAP folder'
			# ... there are problems with folder names :(
			if lst_splitted[0].find('HasChildren') > 0: has = 1
		        else: has = 0
	                ris.append([has, m_name, nm[0]])                    
	    except:
	        try: mailconn.logout()
	        except: pass
	        return 'NO', 'Folder not found or folder error.'
        try: mailconn.logout()
	except: pass
	return 'OK', ris
	    
	    
	    
	    

	
    def delEmail(self,folder=None,msg_list=None):
        """ put emails in trash or definitively expunge them from server (if you are in trash folder) """
	if self.UsePortalData == 1: TRASHfolder = self.TrashFolder
	else: TRASHfolder = self.mailbox_trash

        if not folder or not msg_list:
	   return 'OK', 'No action taken.'
	else:
           typ, conn = self._log_into_server()
	   if typ == 'NO': return typ, conn
	   typ, conn, nemail = self._selectFolder(conn, folder)
	   if typ == 'NO': return typ, conn
	   if type(msg_list) is type(""):
	      del_list=msg_list
	   else:
	      del_list=string.join(msg_list,',')
	   if folder == TRASHfolder:
              typ, dat = conn.store(del_list,'+FLAGS',('\Deleted'))
              if typ == 'NO':
                 return typ, dat
	      typ, dat = conn.expunge()
	      if type(msg_list) is type(""):
   	         msg = '1 Email deleted.'
	      else:
		 msg = str(len(msg_list)) + ' Emails deleted.'
	   else:
	      try: typ, dat = conn.copy(del_list,TRASHfolder)
              except: 
	          conn.logout()
		  return 'NO', 'Error copying to Trash folder'
	      if typ == 'NO': return typ, TRASHfolder
	      try: 
	          typ, dat = conn.store(del_list,'+FLAGS',('\Deleted'))
              except: 
	          conn.logout()
		  return 'NO', 'Error storing flag DELETED'
	      if typ == 'NO': return typ, 'Error storing flag DELETED'
	      try: typ, dat = conn.expunge()
              except: 
	          conn.logout()
		  return 'NO', 'Error expunging deleted emails.'
	      if type(msg_list) is type(""):
   	         msg = '1 Email moved in Trash folder.'
	      else:
     	         msg = str(len(msg_list)) + ' Emails moved in Trash folder.'
	   if typ == 'NO': return typ, dat
	   conn.logout()
           return 'OK', msg
		    
	    
	    
    def sendEmail(self, REQUEST):
        """ Send an Email message """
	if self.UsePortalData == 1: SMTPserver = self.SMTPServer
	else: SMTPserver = self.mailserver_smtp

	try:
	   outbox=smtplib.SMTP(SMTPserver)
	except:
           return 'NO', 'Cannot contact SMTP server.'
        attachment=REQUEST['attached_file']
        h = self._make_header(self.account_name)
        h.append(' <' + self.account_email + '>', 'us-ascii')
        me = h
	recipients = []
	fields = ['to', 'cc', 'bcc']
	for field in fields:
	    if REQUEST[field]:
		recipients.extend(map(str.strip, REQUEST[field].split(',')))
	#you = str(REQUEST['to']) + ', ' + str(REQUEST['cc']) + ', ' + str(REQUEST['bcc'])


	if REQUEST.has_key('format_html'): message_format = 'html'
	else: message_format = 'plain'

        if attachment.filename != '' :
            new_email = MIMEMultipart()
	else:
            try:
                new_email = MIMEText(unicode(REQUEST['message'],'utf-8').
                                     encode(self.CharsetCoding),
                                     message_format,self.CharsetCoding)
            except UnicodeEncodeError:
                new_email = MIMEText(REQUEST['message'],message_format,'utf-8')
        new_email['Subject'] = self._make_header(str(REQUEST['subject']))
        new_email['From'] = me
        new_email['To'] = str(REQUEST['to'])
        if REQUEST['cc']:
            new_email['Cc'] = str(REQUEST['cc'])

	new_email['Date'] = DateTime().rfc822()
        if attachment.filename != '' :
            try:
                msg = MIMEText(unicode(REQUEST['message'],'utf-8').
                               encode(self.CharsetCoding),
                               message_format,self.CharsetCoding)
            except UnicodeEncodeError:

                msg = MIMEText(REQUEST['message'], message_format, 'utf-8')
            new_email.attach(msg)
	    new_email.preamble = 'Attachment from PloneWebMail module'
            new_email.epilogue = ''
	    atta=self._create_attachment(attachment)
            new_email.attach(atta)
	try:
	    #sent_msg=outbox.sendmail(me, string.split(you,', '), new_email.as_string())
	    sent_msg=outbox.sendmail(me, recipients, new_email.as_string())
	except:
           return 'NO', 'Cannot send: check the address of the SMTP server.'
	if self.UsePortalData == 1: SENTmailbox = self.SentFolder
	else: SENTmailbox = self.mailbox_sent	
        typ, mailconn = self._log_into_server()
	if typ == 'NO':
	    return typ, mailconn
        else:
            typ, dat, nemails = self._selectFolder(mailconn, SENTmailbox)
        if typ == 'NO':
	   return typ, dat
	typ, ris = dat.append(SENTmailbox,('\\Seen'),None,string.replace(new_email.as_string(), "\n", "\r\n"))
        if typ == 'NO':
	   return typ, 'Message correctly send but unable to copy in Sent folder.'
	dat.logout()
	outbox.close()
	return 'OK', 'Email sent.'



    def replyEmail(self,folder=None,msg_list=None,replyall=0,REQUEST=None,RESPONSE=None):
	""" reply message """
        if not folder or not msg_list:
	   return 'NO', 'No Email selected, no action taken.'
	else:
	   if type(msg_list) is not type(""):
	      return 'NO', 'Select 1 Email only for Reply action.'
	typ, dat = self.getCompleteEmail(folder,msg_list)
        if typ == 'NO':
           return typ, dat
	body, body_type = self.getBody(dat)
	new_body = '\n'
	for line in body.split("\n") :
	    new_body = new_body + ">" + line + "\n"
	new_subject = 'Re: %s' % self.getSubject(dat)
        new_to = ''
        if replyall == '0':
            if dat.has_key('reply-to'): new_to = dat['reply-to']
	    if new_to == '': new_to = dat['From']
	    realname, address  = parseaddr(new_to)
	    new_to = address
	else:
	    if dat.has_key('reply-to'):
	        realname, address  = parseaddr(dat['reply-to'])
                new_to = address
	    realname, address  = parseaddr(dat['From'])
	    if address <> '':
               if new_to == '': new_to = address
	       else: new_to += ', ' + address
	    if dat.has_key('Cc'):
	        realname, address  = parseaddr(dat['Cc'])
	        if address <> '':
                   if new_to == '': new_to = address
	           else: new_to += ', ' + address

        path_rel = {'MSG_TO':new_to,'MSG_BODY':new_body,'MSG_SUBJECT': new_subject}
	return 'OK', path_rel



    def forwardEmail(self,folder=None,msg_list=None,REQUEST=None,RESPONSE=None):
	""" forward message """
        if not folder or not msg_list:
	   return 'NO', 'No Email selected, no action taken.'
	else:
	   if type(msg_list) is not type(""):
	      return 'NO', 'Select 1 Email only for Forward action.'
	typ, dat = self.getCompleteEmail(folder,msg_list)
        if typ == 'NO':
           return typ, dat
	body, body_type = self._msgBody(dat)
	new_body = '\r\n-----Forwarded message -------\r\n' + body
	new_subject = 'Fwd: %s' % self.getSubject(dat)
	#path_rel = urllib.urlencode({'MSG_BODY':new_body,'MSG_SUBJECT': new_subject})

        # assign a dictionary instead of urlencode - vietdt
        path_rel = {'MSG_BODY':new_body,'MSG_SUBJECT': new_subject}
	return 'OK', path_rel



    def createMailbox(self,new_box=None):
        """ Create new mailbox """
	if (new_box == None or new_box == ''): return 'OK', 'No mailbox specified. No action taken.'
        typ, mailconn = self._log_into_server()
	if typ == 'NO': return typ, 'Error: login failed.'
	try:
	    typ, dat = mailconn.create(new_box)
	except:
	    return 'NO', 'Error creating mailbox'
	try: mailconn.close()
	except: pass
	return 'OK', dat[0]



    def deleteMailbox(self,box_name=None):
        """ Delete new mailbox """
	if (box_name == None or box_name == ''): return 'OK', 'No mailbox specified. No action taken.'
        typ, mailconn = self._log_into_server()
	if typ == 'NO': return typ, 'Error: login failed.'
	try:
	    typ, dat = mailconn.delete(box_name)
	except:
	    return 'NO', 'Error creating mailbox'
	try: mailconn.close()
	except: pass
	return 'OK', dat[0]


    def copyToMailbox(self,select_email=None,folder=None,to_folder=None,copymove=''):
        """ copy/move email(s) from a folder to a folder """
    	if (select_email == None or select_email == '' or to_folder == None or to_folder == ''): return 'OK', 'No action taken.'
        typ, mailconn = self._log_into_server()
	if typ == 'NO':
	    return typ, mailconn
        else:
            typ, mailconn, nemails = self._selectFolder(mailconn, folder)
	if typ == 'NO': return typ, 'Error: login failed.'
        if type(select_email) is type(""):
	    email_list=select_email
	else:
	    email_list=string.join(select_email,',')
	typ, dat = mailconn.copy(email_list,to_folder)
	if typ == 'NO': return typ, dat[0]
	if copymove == 'move':
	    typ, dat = mailconn.store(email_list,'+FLAGS',('\Deleted'))
            if typ == 'NO':
                return typ, dat
	    typ, dat = mailconn.expunge()
	if typ == 'NO': return typ, dat
	try: mailconn.close()
	except: pass
	return 'OK', 'Email moved succesfully'




    def getCompleteEmail(self,folder=None,num=None):
        """get HEADERS and BODY of a specified mail"""
	if folder == None: 
	    if self.UsePortalData: folder=self.IncomingFolder
	    else: folder=self.mailbox_inbox
        typ, mailconn = self._log_into_server()
	if typ == 'NO':
	    return typ, mailconn
        else:
            typ, mailconn, nemails = self._selectFolder(mailconn, folder)
        if typ == 'NO':
	    return typ, mailconn
	typ, data = mailconn.fetch(num,'(RFC822)')
        if typ == 'NO':
	    return typ, mailconn
	email_obj  = email.message_from_string(data[0][1])
	try: mailconn.close()
	except: pass
	return 'OK', email_obj



    def hasAttachments(self, email_obj=None) :
	""" returns 1 if the email has attachements """
	if email_obj.is_multipart() :
	    return 1
	else :
	    type = email_obj.get_type()
	    if type == 'application/octet-stream' :
		return 1
	    return 0


    def getAttachments(self, email_obj=None):
	""" returns a list describing the attachements """
	ret = []
	if not email_obj.is_multipart()  :
	    type = email_obj.get_type()
	    if type == 'application/octet-stream' :
		counter = 1
		filename = email_obj.get_filename()
		lst = ( ('counter', counter),
			('filename', filename),
			('Content-Type',type),)
		ret.append(lst)
	    return ret
	else :
	    counter = -1
	    txtcount = 0
	    for msg in self._getLoads(email_obj) :
		counter = counter + 1
		type = msg.get_type()
		if type == None :
		    txtcount = txtcount + 1
		    continue
		if type == 'text/plain' :
		    if txtcount == 0 :
			txtcount = txtcount + 1
			continue
		filename = msg.get_param('name')
		if filename == None :
		    filename = "attachment %s" % counter
		filename = self._header_utf8(filename)
		lst = ( ('counter', counter), ('filename', filename),('Content-Type',type),)
		ret.append(lst)
	return ret



    def getAttachment(self, number, REQUEST=None,RESPONSE=None,folder=None,num=None,attach_name='ATTACH') :
	"""returns attachment number #... """
	if folder == None: 
	    if self.UsePortalData: folder=self.IncomingFolder
	    else: folder=self.mailbox_inbox
	typ, email_obj = self.getCompleteEmail(folder,num)
	number = int(number)
	maintype = email_obj.get_type()
	if maintype == 'application/octet-stream' :
	    RESPONSE.setHeader('Content-Type', maintype)
	    RESPONSE.setHeader('Content-Length', str(email_obj.get_size))
	    RESPONSE.setHeader('Content-Disposition', 'filename=%s' % \
			       attach_name)
	    return email_obj.get_payload(decode=1)
	msg = self._getLoads(email_obj,number)
	msg_type = msg.get_type()
	if msg_type == 'message/rfc822' :
	    msg_type = 'text/plain'
	RESPONSE.setHeader('Content-Type', msg_type)
	RESPONSE.setHeader('Content-Disposition', 'filename=%s' % \
                           attach_name)
	return msg.get_payload(decode=1)





    def getFrom(self,email_obj=None,only_name=1) :
	""" returns the sender of the email """
	if email_obj['From'] == '' :
	    return ''
	stringa = self.decodeIsoStr(email_obj['From'])   
	realname, address  = parseaddr(stringa)
	stringa = self._format_address(realname,address,only_name)
	return stringa



    def getTo(self,email_obj=None) :
	""" returns who message was sent to"""
	tos = email_obj.get_all('To')
	if tos== [''] :
	    return ''
	to_lst = getaddresses(tos)
	comma_flag = 0
	str = ''
	for to  in to_lst :
	    realname = to[0]
	    realname = self.decodeIsoStr(to[0])   
	    address  = to[1]
	    if not comma_flag :
		str = self._format_address(realname,address)
		comma_flag = 1
	    else :
		str = str + ", " + self._format_address(realname,address)
	if str == '':
	    str = tos[0]
	return str



    def getCc(self,email_obj=None) :
	""" returns who message was sent in cc"""
	ccs = email_obj.get_all('Cc', [])
	if ccs== [] :
	    return ''
	cc_lst = getaddresses(ccs)
	comma_flag = 0
	str = ''
	for cc  in cc_lst :
	    realname = cc[0]
	    realname = self.decodeIsoStr(cc[0])   
	    address  = cc[1]
	    if not comma_flag :
		str = self._format_address(realname,address)
		comma_flag = 1
	    else :
		str = str + ", " + self._format_address(realname,address)
	if str == '':
	    str = ccs[0]
	return str



    def getSubject(self,email_obj=None) :
	""" returns the subject of the mails """
	try:
            if email_obj['Subject']=="":
                sbjct="No Subject"
            else:
                sbjct = self.decodeIsoStr(st=email_obj['Subject'])
            return sbjct
	except: return "No Subject"
	
	    
	    
	    
	    
	    
	    
    def getBody(self,email_obj=None) :
	""" returns the html formated body of the messages """
	type = email_obj.get_type()
	body = self._msgBody(email_obj)
	if type == 'application/octet-stream' :
	    return ''
	return body
	    
	    
	    
	    
	    
    def urlquote(self,st=None):
        return urllib.quote(st)
    

	

    def format4addressbook(self,st=None):
        """ Format name, lastname, and email for easy insert in personal_addressbook """
        if st == None: return 'NO', 'String not found. No action taken.'
	firstname=''
	lastname=''
	st = st.replace('&lt;','<')
	st = st.replace('&gt;','>')
	realname, address = parseaddr(st)
	if realname <> '':
           firstname = realname.split(' ')[0]
	   if (len(firstname)+1) < realname:
	       lastname = realname[len(firstname)+1:]
	return firstname,lastname,address
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
		    
	    
	    
	    
	    
	    
#################################### UTILITIES #####################################


    # DEBUG DEF
    def returnImapObj(self):
	mailconn = imaplib.IMAP4('mailserver')
        mailconn.login('user','pass3')
	mailconn.select('INBOX')
	return mailconn.fetch(13,'(RFC822.HEADER)')




    def _log_into_server(self):
        """ Login into mailserver and select folder """
	if self.UsePortalData == 1: mailserver = self.IMAPServer
	else: mailserver = self.mailserver
	username = self.username
	password = self.password
	try:
            mailconn = imaplib.IMAP4(mailserver)
        except:
            return 'NO', 'Cannot connect to mailserver'
	try:
	    typ, data = mailconn.login(username, password)
	except: 
            mailconn.logout()
	    return 'NO', 'Login or password invalid'   
        return typ, mailconn

	    
	    
	    

    def _fetch_header(self, mailconn, num):
        """ I know it's a little tricky, but it works... """
        try:
            typ, data = mailconn.fetch(num,'(RFC822.HEADER)')
	    if typ == 'NO':
	        return typ, 'Error : message not found.'
	    typ, uid = mailconn.fetch(num,'(UID)')
    	    if typ == 'NO':
	        return typ, 'Error : message not found.'
	    typ, flags = mailconn.fetch(num,'FLAGS')
    	    if typ == 'NO':
	        return typ, 'Error : flags not found.'
            p = Parser()
            m = p.parsestr(data[0][1])
            m['UID'] = (uid[0][uid[0].find('UID')+4:-1])
            m['FLAGS'] = imaplib.ParseFlags(flags[0])
            m['NUM'] = num
            return 'OK', dict(m)
        except:
	    mailconn.logout()
	    return 'NO', 'Error : cannot fetch Email header.'
	    
	    
    def _selectFolder(self, mailconn, folder):
        """ Enter a specifyed folder and return nemails """
        try:
            typ, [totemails] = mailconn.select(folder)
            if typ == 'NO':
                return typ, 'Folder not found', 0
	    else:
                return typ, mailconn, totemails
        except:
	    return 'NO','Folder not found', 0








    def _format_address(self,realname,address,onlyname=0) :
	""" returns a html formated text of realname, address
	if onlyname: returns only realname, if no realname, returns address """
	address = self._highlight_links(address)[:-1]
	if realname != '' :
	    if address != '' :
		if onlyname :
		    ret = realname
		else :
		    ret = realname + " &lt;%s&gt;" % address
	    else :
		ret = realname
	else :
	    ret = address
	return ret
	    
	    
	    
    def _highlight_links(self,txt):
	""" change appeareance of email, urls """
	ret = ""
	for line in string.split(txt,"\n") :
	    # format < and > symbols to avoid confusin with html tag
	    line = self._change_larger_smaller(line)
	    # change emails
	    pat = re.findall("([a-zA-Z0-9\._-]*)@([a-zA-Z0-9\._-]*)",line)

	    if  pat != None:
		for group in pat :
		    user  = group[0]
		    server= group[1]
		    str = "%s@%s" % (user,server)
		    line = string.replace(line,str, str)
	    # change urls
	    pat2 = re.search("(http://[a-zA-Z:0-9\.#_\-\/]*)",line)
	    if pat2 != None :
		url = pat2.group(1)
		line = string.replace(line,url,'<a href="%s">%s</a>' % (url,url))
	    # colors for replies
	    color1 = "#CE007B"
	    color2 = "#299C39"
	    # color replied sentences
	    pat3 = re.search('^&gt; &gt;(.*)',line)
	    if pat3 != None :
		line = '<font color="%s">%s</font>' % (color2, line)
	    else :
		pat4 = re.search('^&gt;(.*)',line)
		if pat4 != None :
		    line = '<font color="%s">%s</font>' % (color1, line)
	    ret = ret + line + "\n"
	return ret
	    
	    
	
    def _change_larger_smaller(self,line) :
	line = string.replace(line, "<", "&lt;")
	line = string.replace(line, ">", "&gt;")
	line = string.replace(line, '"', "&#34;")
	return line	
	    
	    

	
	
    def _headers2dictionary(self, text):
        """ Taking text in the format of a header block convert to a dictionary """
        last_dict = None
        resultDictionary = {}
        if text != None:
            for each in string.split(text, '\r\n'):
                line = string.split(each, ':')
                if len(line) > 1:
                    last_dict = string.upper(line[0])
                    resultDictionary[string.upper(line[0])] = string.join(line[1:], ':')
                elif len(line[0]) > 1 and line[0][0] in string.whitespace and last_dict is not None:
                    resultDictionary[last_dict] = resultDictionary[last_dict] + line[0][1:]
        return resultDictionary

	
	
    def decodeIsoStr(self,st=None) :
    	""" decode string """ 
    	if st == None: return None
        try:
            ret_st = ''
            for i in email.Header.decode_header(st):
                st_out, coding = i
                ret_st += self._convert_utf8(st_out,coding)
        except: ret_st=st
        return ret_st
	

	
	
    def _getLoads(self, message,number=None) :
	""" recursively goes through all payloads and builds up a list of them.
	needed to convert the possible tree organization of the attachments into a
	linear organization """
	lst = []
	msgs = message.get_payload()
	type = message.get_type()
	if type == 'application/octet-stream' :
	    lst.append(msgs)
	    return lst

	for msg in msgs :
	    if msg.is_multipart() :
		loads = self._getLoads(msg)
		lst = lst + loads
	    else :
		lst.append(msg)
	if number != None :
	    return lst[number]
	return lst
		
	

	
    def _msgBody(self,email_obj=None):
	""" returns the 'body' of the message """
	if email_obj.is_multipart()  :
	    for msg in self._getLoads(email_obj) :
		type = msg.get_type()
		if type == None :
		    type = 'text/plain'
		if type == 'text/plain' :
		    st = msg.get_payload(decode=1)
                    cs = email_obj.get_charsets()[1]
                    st = self._convert_utf8(st, cs)
                    return st, 'text'
		if type == 'text/html' :
		    return msg.get_payload(decode=1), 'html'
	    return ""
	else :
	    """ Some problems with UTF-8 coding.... solved with this tricky: """
            st = email_obj.get_payload(decode=1)
	    if st is None: return "", body_type
	    cs = email_obj.get_charsets()[0]
	    st = self._convert_utf8(st, cs)
	    st = email.quopriMIME.decode(st)
	    if email_obj.get_type() == 'text/html': return st, 'html'
	    else: return st, 'text'
		


    def _create_attachment(self,attachment) :
	""" creates an attachment """
	head_str = str(attachment.headers)
	header = self._headers2dictionary(head_str)
	cont_type =  string.strip(header['CONTENT-TYPE'])
	atta = _Message()
	h = self._make_header(attachment.filename)
	atta.add_header('Content-Type',cont_type, name=str(h))
	atta.add_header('Content-Disposition', 'attachment', filename=str(h))
	atta.set_payload(attachment.read())
	Encoders.encode_base64(atta)
	return atta	    
	    

		    		
		
    def _convert_utf8(self, st, enc):
        if enc is not None:
            try:
                st = unicode(st, enc,'replace').encode('utf-8')
            except LookupError, e:
                st = str(e)
        return st

    def _header_utf8(self, header):
        st, enc = email.Header.decode_header(header)[0]
        return self._convert_utf8(st,enc)

    def _make_header(self, st):
        try:
            h = Header.Header(st)
        except UnicodeDecodeError:
            try:
                h = Header.Header(unicode(st,'utf-8').encode(self.CharsetCoding), self.CharsetCoding)
            except UnicodeDecodeError:
                h = Header.Header(st, 'utf-8')
        return h
		
			    	    
InitializeClass(portal_webmail) 