## Plone Web Mail
## Copyright (C) 2004, OPENPROJECTS, http://openprojects.it
## Maintained by Giorgio Pieretti <giorgio.pieretti at openprojects.it>
## Released under GPL version 2
## See LICENSE.txt or http://www.gnu.org/copyleft/gpl.html

from Products.CMFCore import utils
from Products.PloneWebMail.PloneWebMailTool import portal_webmail
from Products.PloneWebMail.config import PKG_NAME, SKIN_NAME
import sys, PloneWebMail_box
from Products.CMFCore.DirectoryView import registerDirectory


tools = ( portal_webmail, ) 
this_module = sys.modules[ __name__ ]
contentClasses = (PloneWebMail_box.PloneWebMail_box,PloneWebMail_addressbook.PloneWebMail_addressbook,)
z_bases = utils.initializeBasesPhase1(contentClasses, this_module)            
z_tool_bases = utils.initializeBasesPhase1(tools, this_module)
contentConstructors = (PloneWebMail_box.addPloneWebMail_box,PloneWebMail_addressbook.addPloneWebMail_addressbook,)
install_globals = globals()

registerDirectory('skins', globals())

def initialize(context): 
    utils.ToolInit('PloneWebMail Tool', tools=tools, 
                   product_name=PKG_NAME, icon='tool.gif',  
                   ).initialize(context) 
    utils.initializeBasesPhase2( z_bases, context )
    utils.initializeBasesPhase2( z_tool_bases, context )
    utils.ContentInit('%s Content' % PKG_NAME,
                      content_types = contentClasses,
                      permission = "Add PloneWebMail_box",
                      extra_constructors = contentConstructors,
                      fti = (PloneWebMail_box.factory_type_information,),
		      ).initialize(context)
    utils.registerIcon(PloneWebMail_box.PloneWebMail_box, 'skins/'+SKIN_NAME+'/PloneWebMail_box.png', globals())